//----
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 LimeGreen
#property indicator_color2 Gold
#property indicator_color3 Gold

#property indicator_color4 Blue//wick
#property indicator_color5 Red//wick
#property indicator_color6 Blue//candle
#property indicator_color7 Red//candle
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 3
#property indicator_width7 3


extern int degree = 3;
extern double kstd = 1.0;
extern int bars = 250;
extern int shift = 0;

extern int	BarWidth			= 1,
				CandleWidth		= 3;


//-----
double fx[],sqh[],sql[];

double ai[10,10],b[10],x[10],sx[20];
double sum; 
int ip,p,n,f;
double qq,mm,tt;
int ii,jj,kk,ll,nn;
double sq;
double error=0;
int num=10;
int grau=10;
double erromed;
double erroreg;
int d=0;
double error2=0;
int num2=10;
int grau2=10;
double erromed2;
double erroreg2;
double edif;
double slope;
double slope2;
double slopeant;
double ac;


int i0 = 0;

double Bar1[],
		 Bar2[],
		 Candle1[],
		 Candle2[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{

  IndicatorBuffers(7);

  SetIndexBuffer(0, fx);
  SetIndexBuffer(1, sqh);
  SetIndexBuffer(2, sql);

  SetIndexStyle(0, DRAW_LINE);
  SetIndexStyle(1, DRAW_LINE);
  SetIndexStyle(2, DRAW_LINE);

  SetIndexEmptyValue(0, 0.0);
  SetIndexEmptyValue(1, 0.0);
  SetIndexEmptyValue(2, 0.0);
  
  SetIndexShift(0, shift);
  SetIndexShift(1, shift);
  SetIndexShift(2, shift);

  SetIndexBuffer(4,Bar1);
  SetIndexBuffer(5,Bar2);				
  SetIndexBuffer(6,Candle1);
  SetIndexBuffer(7,Candle2);
  SetIndexStyle(4,DRAW_HISTOGRAM,0,BarWidth);
  SetIndexStyle(5,DRAW_HISTOGRAM,0,BarWidth);
  SetIndexStyle(6,DRAW_HISTOGRAM,0,CandleWidth);
  SetIndexStyle(7,DRAW_HISTOGRAM,0,CandleWidth);



  return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
  //clear();
  return(0);
}

//+------------------------------------------------------------------+




//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{

if(Seconds()<=5)

{

for(degree=1;degree<=8;degree++)

{

for(bars=25*degree;bars<=1000;bars++)

{

  if (Bars < bars) return;

//---- 
    
  int mi; 
  ip = bars;
  p=ip;
  sx[1]=p+1;
  nn = degree+1;

  SetIndexDrawBegin(0, Bars-p-1);
  SetIndexDrawBegin(1, Bars-p-1);
  SetIndexDrawBegin(2, Bars-p-1); 
   
//----------------------sx-------------------------------------------------------------------
  for(mi=1;mi<=nn*2-2;mi++)
  {
    sum=0;
    for(n=i0;n<=i0+p;n++)
    {
       sum+=MathPow(n,mi);
    }
    sx[mi+1]=sum;
  }  
  //----------------------syx-----------
  for(mi=1;mi<=nn;mi++)
  {
    sum=0.00000;
    for(n=i0;n<=i0+p;n++)
    {
       if(mi==1) sum+=((Close[n+d]+Open[n+d]+High[n+d]+Low[n+d])/4);
       else sum+=((Close[n+d]+Open[n+d]+High[n+d]+Low[n+d])/4)*MathPow(n,mi-1);
    }
    b[mi]=sum;
  } 
//===============Matrix=======================================================================================================
  for(jj=1;jj<=nn;jj++)
  {
    for(ii=1; ii<=nn; ii++)
    {
       kk=ii+jj-1;
       ai[ii,jj]=sx[kk];
    }
  }  
//===============Gauss========================================================================================================
  for(kk=1; kk<=nn-1; kk++)
  {
    ll=0;
    mm=0;
    for(ii=kk; ii<=nn; ii++)
    {
       if(MathAbs(ai[ii,kk])>mm)
       {
          mm=MathAbs(ai[ii,kk]);
          ll=ii;
       }
    }
    if(ll==0) return(0);   
    if (ll!=kk)
    {
       for(jj=1; jj<=nn; jj++)
       {
          tt=ai[kk,jj];
          ai[kk,jj]=ai[ll,jj];
          ai[ll,jj]=tt;
       }
       tt=b[kk];
       b[kk]=b[ll];
       b[ll]=tt;
    }  
    for(ii=kk+1;ii<=nn;ii++)
    {
       qq=ai[ii,kk]/ai[kk,kk];
       for(jj=1;jj<=nn;jj++)
       {
          if(jj==kk) ai[ii,jj]=0;
          else ai[ii,jj]=ai[ii,jj]-qq*ai[kk,jj];
       }
       b[ii]=b[ii]-qq*b[kk];
    }
  }  
  x[nn]=b[nn]/ai[nn,nn];
  for(ii=nn-1;ii>=1;ii--)
  {
    tt=0;
    for(jj=1;jj<=nn-ii;jj++)
    {
       tt=tt+ai[ii,ii+jj]*x[ii+jj];
       x[ii]=(1/ai[ii,ii])*(b[ii]-tt);
    }
  } 
//===========================================================================================================================
  for(n=i0;n<=i0+p;n++)
  {
    sum=0;
    for(kk=1;kk<=degree;kk++)
    {
       sum+=x[kk+1]*MathPow(n,kk);
    }
    fx[n]=x[1]+sum;
  } 
//-----------------------------------Std-----------------------------------------------------------------------------------
  sq=0.0;
  
  if(d==0)
  
  {
  double emean = iBands(NULL, 0, bars, 1, 0, (MODE_CLOSE+MODE_OPEN+MODE_HIGH+MODE_LOW)/4, MODE_UPPER, 0)- iMA(NULL, 0, bars, 0, MODE_SMA, (MODE_CLOSE+MODE_OPEN+MODE_HIGH+MODE_LOW)/4,0);
  }
  
  for(n=i0;n<=i0+p;n++)
  {
    sq+=MathPow(((Close[n+d]+Open[n+d]+High[n+d]+Low[n+d])/4)-fx[n],2);
  }    

  if(d==0)
  {
  double r2=1-(sq/(MathPow(emean,2)*bars));
  }

  sq=sq/(bars);

  sq=MathSqrt(sq);

  if(r2>error && d==0)
  {
  d=1;
  bars=bars-2;
  error2=r2;
  grau2=degree;
  num2=bars;
  erromed2=emean;
  erroreg2=sq;
  slope2=fx[0]-fx[1];
  }

  else
  {
  if(d==1)
  {
  d=0;
  bars=bars+1;
  if(erroreg2<sq)
  {
  error=error2;
  grau=grau2;
  num=num2;
  erromed=erromed2;
  erroreg=erroreg2;
  edif=erroreg2-sq;
  slopeant=fx[0]-fx[1];
  slope=slope2;
  ac=slope-slopeant;
  }
  }
  }   
}
}

degree=grau;
bars=num;
kstd=2;

ObjectCreate("ObjName", OBJ_LABEL, 0, 0, 0);
ObjectSetText("ObjName","r2 "+error+" gr "+degree+" n "+bars+" eM "+erromed+" eR "+erroreg+" eD "+edif,6, "Verdana", Red);
ObjectSet("ObjName", OBJPROP_CORNER, 0);
ObjectSet("ObjName", OBJPROP_XDISTANCE, 20);
ObjectSet("ObjName", OBJPROP_YDISTANCE, 20);

ObjectCreate("ObjName2", OBJ_LABEL, 0, 0, 0);
ObjectSetText("ObjName2","sl "+slope+" slant "+slopeant+" ac "+ac,6, "Verdana", Red);
ObjectSet("ObjName2", OBJPROP_CORNER, 0);
ObjectSet("ObjName2", OBJPROP_XDISTANCE, 20);
ObjectSet("ObjName2", OBJPROP_YDISTANCE, 40);



  if (Bars < bars) return;

//---- 
    
  int mi2;
  ip = bars;
  p=ip;
  sx[1]=p+1;
  nn = degree+1;

  SetIndexDrawBegin(0, Bars-p-1);
  SetIndexDrawBegin(1, Bars-p-1);
  SetIndexDrawBegin(2, Bars-p-1); 
   
//----------------------sx-------------------------------------------------------------------
  for(mi2=1;mi2<=nn*2-2;mi2++)
  {
    sum=0;
    for(n=i0;n<=i0+p;n++)
    {
       sum+=MathPow(n,mi2);
    }
    sx[mi2+1]=sum;
  }  
  //----------------------syx-----------
  for(mi2=1;mi2<=nn;mi2++)
  {
    sum=0.00000;
    for(n=i0;n<=i0+p;n++)
    {
       if(mi2==1) sum+=((Close[n]+Open[n]+High[n]+Low[n])/4);
       else sum+=((Close[n]+Open[n]+High[n]+Low[n])/4)*MathPow(n,mi2-1);
    }
    b[mi2]=sum;
  } 
//===============Matrix=======================================================================================================
  for(jj=1;jj<=nn;jj++)
  {
    for(ii=1; ii<=nn; ii++)
    {
       kk=ii+jj-1;
       ai[ii,jj]=sx[kk];
    }
  }  
//===============Gauss========================================================================================================
  for(kk=1; kk<=nn-1; kk++)
  {
    ll=0;
    mm=0;
    for(ii=kk; ii<=nn; ii++)
    {
       if(MathAbs(ai[ii,kk])>mm)
       {
          mm=MathAbs(ai[ii,kk]);
          ll=ii;
       }
    }
    if(ll==0) return(0);   
    if (ll!=kk)
    {
       for(jj=1; jj<=nn; jj++)
       {
          tt=ai[kk,jj];
          ai[kk,jj]=ai[ll,jj];
          ai[ll,jj]=tt;
       }
       tt=b[kk];
       b[kk]=b[ll];
       b[ll]=tt;
    }  
    for(ii=kk+1;ii<=nn;ii++)
    {
       qq=ai[ii,kk]/ai[kk,kk];
       for(jj=1;jj<=nn;jj++)
       {
          if(jj==kk) ai[ii,jj]=0;
          else ai[ii,jj]=ai[ii,jj]-qq*ai[kk,jj];
       }
       b[ii]=b[ii]-qq*b[kk];
    }
  }  
  x[nn]=b[nn]/ai[nn,nn];
  for(ii=nn-1;ii>=1;ii--)
  {
    tt=0;
    for(jj=1;jj<=nn-ii;jj++)
    {
       tt=tt+ai[ii,ii+jj]*x[ii+jj];
       x[ii]=(1/ai[ii,ii])*(b[ii]-tt);
    }
  } 
//===========================================================================================================================
  for(n=i0;n<=i0+p;n++)
  {
    sum=0;
    for(kk=1;kk<=degree;kk++)
    {
       sum+=x[kk+1]*MathPow(n,kk);
    }
    fx[n]=x[1]+sum;
  } 
//-----------------------------------Std-----------------------------------------------------------------------------------
  sq=0.0;
  for(n=i0;n<=i0+p;n++)
  {
    sq+=MathPow(((Close[n]+Open[n]+High[n]+Low[n])/4)-fx[n],2);
  }
  sq=MathSqrt(sq/(bars))*kstd;


  for(n=i0;n<=i0+p;n++)
  {
    sqh[n]=fx[n]+sq;
    sql[n]=fx[n]-sq;
  }
  
  for(n=i0;n<=1;n++)
  {
    if(fx[n]-fx[n+1]<0)
    {SetCandleColor(1,n);}
    if(fx[n]-fx[n+1]>0)
    {SetCandleColor(2,n);}
  }


}
  return(0);
}
//+------------------------------------------------------------------+


void SetCandleColor(int col, int i)
{
	double high,low,bodyHigh,bodyLow;


	{
		bodyHigh = MathMax(Open[i],Close[i]);
		bodyLow  = MathMin(Open[i],Close[i]);
		high		= High[i];
		low		= Low[i];
	}

	Bar1[i] = low;	Candle1[i] = bodyLow;
	Bar2[i] = low;	Candle2[i] = bodyLow;
	

	switch(col)
	{
		case 1: 	Bar1[i] = high;	Candle1[i] = bodyHigh;	break;
		case 2: 	Bar2[i] = high;	Candle2[i] = bodyHigh;	break;
	
	}
}

